#include "fivewin.ch"
#include "calendar.ch"
#include "calex.ch"
#include "tselex.ch"
#include "ord.ch"

REQUEST DBFCDX

function Main()

   SET DATE FORMAT "MM/DD/YYYY"
   SET DELETE ON

   SampleCalex():New()

return nil

//---------------------------------------------------//

CLASS SampleCalex

   DATA dDateStart, dDateEnd
   
   DATA cAlias
   
   DATA lOnPreNext
   
   DATA oCalex
   DATA oDtPick
   DATA oExBar   
   DATA oPanelExplorer
   DATA oPanelCalex
   DATA oWnd
   DATA oSelex
   
   METHOD New()

   METHOD AddDates()

   METHOD BuildCalex  
   METHOD BuildExplorer
   METHOD BuildPanels()
   
   METHOD ChangeSelex()
   
   METHOD SetSize( nType, nWidth, nHeight )
   
ENDCLASS

//---------------------------------------------------//

METHOD New() CLASS SampleCalex
   
   local oMenu
   local oSelf := Self
   
   MENU oMenu
   ENDMENU
   
   ::dDateStart = Date()
   ::dDateEnd   = Date()
   
   ::lOnPreNext = .F.
   
   ::cAlias = "citas"
   
   USE citas ALIAS ( ::cAlias ) VIA "DBFCDX"
   INDEX ON DToS( CITAS->DSTART ) + Str( CITAS->START, 4 ) TAG fecha TO citas
   
   DEFINE WINDOW ::oWnd MDI MENU oMenu
   
   ::BuildPanels()
   ::BuildExplorer()
   ::BuildCalex()
//   ::Adddates()
   
   ACTIVATE WINDOW ::oWnd MAXIMIZED;
            ON RESIZE oSelf:SetSize( nSizeType, nWidth, nHeight )
 
   
RETURN Self

//---------------------------------------------------//

METHOD AddDates( dStart, dEnd, nStart, nEnd ) CLASS SampleCalex

   local dDate
   
   // compat with xharbour   
   DEFAULT dStart := CToD( "  /  /  " )
   DEFAULT dEnd := CToD( "  /  /  " )
   
   //Clear scopes
   ( ::cAlias )->( OrdScope( TOPSCOPE, NIL ) )
   ( ::cAlias )->( OrdScope( BOTTOMSCOPE, NIL ) )
   
   //Set New scopes
   ( ::cAlias )->(  DBGoTop() )
   ( ::cAlias )->( OrdScope( TOPSCOPE, DToS( dStart ) + Str( nStart * 100, 4 ) ) )
   ( ::cAlias )->( OrdScope( BOTTOMSCOPE, DToS( dEnd ) + Str( nEnd * 100, 4 ) ) )
   ( ::cAlias )->(  DBGoTop() )
   
   ::oCalex:Reset()
   DO WHILE ! ( ::cAlias )->( Eof() )
      ::oCalex:LoadDates( ( ::cAlias )->START,;
                          ( ::cAlias )->END, ;
                          ( ::cAlias )->DSTART, ;
                          ( ::cAlias )->DEND, ;
                          ( ::cAlias )->TEXT, ;
                          ( ::cAlias )->SUBJECT )
      ( ::cAlias )->( DBSkip() )
   ENDDO
//   ( ::cAlias )->( DBGoTop() )
//   ( ::cAlias )->( Browse() )
//   ( ::cAlias )->( DBGoTop() )
   
RETURN nil

//---------------------------------------------------//

METHOD BuildCalex() CLASS SampleCalex

   ::oCalex = TCalEx():New( 10, 10,,, ::oPanelCalex )   

   //Months
   ::oCalex:oMonthView:bSelected = {| oSelf, dDate | ::oDtPick:SetDate( dDate ) }
   ::oCalex:oMonthView:bSelectedWeek = {| oSelf, nWeek, dDate | ::oDtPick:SetDate( dDate ) }
   
   ::oCalex:oMonthView:bSelectView   = ;
            { | o, oLast | ::AddDates( o:dStart, o:dEnd, 0, 24 ), ;
                           ::oDtPick:SetDate( o:dDateSelected ) }
                           
   ::oCalex:oMonthView:bOnNext = {| o, dDate | ::oDtPick:SetDate( dDate ), ::AddDates( o:dStart, o:dEnd, 0, 24 ) }
   ::oCalex:oMonthView:bOnPrev = {| o, dDate | ::oDtPick:SetDate( dDate ), ::AddDates( o:dStart, o:dEnd, 0, 24 ) }
    
   //Day
   ::oCalex:oDayView:bSelectView     = ;
             { | o, oLast | ::AddDates( o:dStart, o:dEnd, ::oCalex:oDayView:nStartHour, ::oCalex:oDayView:nEndHour ),;
                            ::oDtPick:SetDate( oLast:dDateSelected ) }
   ::oCalex:oDayView:bOnNext = {| o, dDate | ::oDtPick:SetDate( dDate ), ::AddDates( o:dStart, o:dEnd, 8, 18 ) }
   ::oCalex:oDayView:bOnPrev = {| o, dDate | ::oDtPick:SetDate( dDate ), ::AddDates( o:dStart, o:dEnd, 8, 18 ) }
   ::oCalex:oDayView:nStartHour = 8.00
   ::oCalex:oDayView:nEndHour   = 18.00
   ::oCalex:oDayView:SetInterval( 10 )

   
   //Week
   ::oCalex:oWeekView:bSelectView    = ;
        { | o, oLast | ::oDtPick:SetDate( oLast:dDateSelected - DoW( oLast:dDateSelected ) + 1 ),;
                       ::AddDates( o:dStart, o:dEnd, o:nStartHour, o:nEndHour ) }   
        
        
   ::oCalex:oWeekView:bOnNext = {| o, dDate | ::oDtPick:SetDate( dDate ), ::AddDates( o:dStart, o:dEnd, 6, 19 ) }
   ::oCalex:oWeekView:bOnPrev = {| o, dDate | ::oDtPick:SetDate( dDate ), ::AddDates( o:dStart, o:dEnd, 6, 19 ) }
   ::oCalex:oWeekView:nStartHour = 6.00
   ::oCalex:oWeekView:nEndHour   = 19.00
   ::oCalex:oWeekView:SetInterval( 30 )
   
   
//   ::oCalex:SetDayView( )

   ::oPanelCalex:oClient = ::oCalex

RETURN nil

//---------------------------------------------------//

METHOD BuildExplorer() CLASS SampleCalex

   local oPanel
   local oSelf := Self
   local nOption := 5
   
   ::oExBar := TExplorerBar():New( 0, 0, 250, 300, ::oPanelExplorer )
   
   oPanel := ::oExBar:AddPanel( "Jump To Date", "c:\fwh\bitmaps\32x32\people.bmp", 200 )
   @ 40, 15 CALENDAR ::oDtPick VAR ::dDateStart OF oPanel PIXEL;
              SIZE 220, 157;
              
   ::oDtPick:bChange = { | o | ::oCalex:SetDate( o:GetDate() ), oSelf:oCalex:Refresh(), SysRefresh() }
   
   oPanel := ::oExBar:AddPanel( "View", "c:\fwh\bitmaps\32x32\people.bmp", 130 )
	 oPanel:AddLink( "Daily"  , { || ::oCalex:SetDayView(), ::ChangeSelex()  }, "c:\fwh\bitmaps\16x16\additem.bmp" )
	 oPanel:AddLink( "Weekly" , { || ::oCalex:SetWeekView(), ::ChangeSelex() }, "c:\fwh\bitmaps\16x16\additem.bmp" )
	 oPanel:AddLink( "Monthly", { || ::oCalex:SetMonthView() }, "c:\fwh\bitmaps\16x16\additem.bmp" )

   @ 100, 10 SELEX ::oSelex VAR nOption of oPanel PIXEL size 220, 45;
      ITEMS "5", "10", "15", "20", "30", "60" ;
      GRADIENT OUTTRACK { { 1/2, nRGB( 219, 230, 244 ), nRGB( 207-50, 221-25, 255 ) }, ;
                          { 1/2, nRGB( 201-50, 217-25, 255 ), nRGB( 231, 242, 255 ) } }; 
      LINECOLORS nRGB( 237, 242, 248 ), nRGB( 141, 178, 227 );
      COLORTEXT  CLR_BLACK, CLR_GREEN ;
      ACTION (::oCalex:oView:SetInterval( Val( ::oSelex:aOptions[ nOption ] ) ), ::oCalex:refresh() )
      
   ::oPanelExplorer:oClient = ::oExBar

RETURN nil

//---------------------------------------------------//

METHOD BuildPanels() CLASS SampleCalex

   local oBrush

   ::oPanelExplorer = TPanel():New( 0, 0, ::oWnd:nHeight, 280, ::oWnd:oWndClient )
   
   ::oPanelCalex    = TPanel():New( 0, 281, ::oWnd:nHeight, ::oWnd:nWidth, ::oWnd:oWndClient )
   
   DEFINE BRUSH oBrush COLOR CLR_WHITE
   
   ::oPanelCalex:SetBrush( oBrush )
   
   oBrush:End()


RETURN nil

//---------------------------------------------------//

METHOD ChangeSelex() CLASS SampleCalex
   
   local cInterval := AllTrim( Str( ::oCalex:oView:nInterval * 60, 2 ) )
   local nAt := AScan( ::oSelex:aOptions, cInterval )

   if nAt != 0  .and. ::oSelex:nOption != nAt
      ::oSelex:SetOption( nAt )
      ::oSelex:Refresh()
   endif 
   

RETURN nil

//---------------------------------------------------//

METHOD SetSize( nType, nWidth, nHeight ) CLASS SampleCalex
   
   if nWidth != nil 
      ::oPanelExplorer:Move( , , , nHeight )
      ::oPanelCalex:Move( , , nWidth - ::oPanelExplorer:nRight, nHeight )
   endif
   
RETURN nil

//---------------------------------------------------//