//calinfo.prg


#include "fivewin.ch"
#include "calex.ch"

static nID := 0

CLASS TCalInfo //FROM TControl

   DATA nID AS NUMERIC

   DATA aGradColor
   DATA aCoords
   
   DATA nStart                   //hora que comienza la cita pudiera ser en blanco
   DATA nEnd                     //hora en que termina pudiera ser en blanco. Default to nStart.
   DATA dStart                   //fecha en que comienza la cita
   DATA dEnd                     //fecha en que termina.  Default to dStart
   DATA cText                    //texto a mostrar en celda
   DATA cSubject
    
   DATA lSelected
   DATA lCreated
   DATA lVisible
    
   DATA nClrText                //color del texto
   
   DATA oCalex
   DATA oLast                  // LastCalInfo included
   DATA nFlags
   DATA oFont

   METHOD New()
   
   METHOD BuildDates( nTop, nLeft, nWidth, nHeight, oWnd )
   
   METHOD GetNewId()
   
   METHOD Hide() INLINE ::lVisible := .F.

   METHOD Move( )
   
   METHOD Paint( hDC )
   METHOD PaintOnMonth( hDC )
   METHOD PaintOnWeek( hDC ) INLINE ::PaintOnMonth( hDC )
   
   METHOD Show()  INLINE ::lVisible := .T.
   
   METHOD LButtonDown( nRow, nCol )

   

ENDCLASS

//----------------------------------------------------------------------------// 

METHOD New( oCalex, nStart, nEnd, dStart, dEnd, cText, cSubject, ;
            nClrText, aGradColor ) CLASS TCalInfo

   DEFAULT nEnd   := nStart,;
           dStart := oCalex:dDateSelected,;
           dEnd   := dStart,;
           nClrText := 0,;
           aGradColor := aGradColor
           
   ::nStart   = nStart
   ::nEnd     = nEnd
   ::dStart   = dStart
   ::dEnd     = dEnd
   ::cText    = cText
   ::cSubject = cSubject
   ::nClrText = nClrText
   
   ::lSelected = .F.
   ::lCreated  = .F.
   ::lVisible  = .f.

   ::oCalex   = oCalex
   
   ::aGradColor   = { { 1, nRGB( 225, 234, 247 ), nRGB( 181, 202, 230 ) } } 
   
   ::aCoords = Array( 4 )
   
   ::nID = ::GetNewID()

return Self

//----------------------------------------------------------------------------// 

METHOD BuildDates( nTop, nLeft, nWidth, nHeight, oWnd ) CLASS TCalInfo

   ::Move( nTop , nLeft - 1, Max( nLeft, nLeft + nWidth ) - 1, nTop + nHeight - 1)
   ::oFont = ::oCalex:oFont     
   ::lCreated = .T.
   ::lVisible  = .T.
   
RETURN NIL

//----------------------------------------------------------------------------// 

METHOD GetNewId() CLASS TCalInfo

   nID++
   
   if nID > 1000
      nID = 1 
   endif

return nID

//----------------------------------------------------------------------------// 

METHOD LButtonDown( nRow, nCol ) CLASS TCalInfo
   
   if ::oCalex:oCalInfo == NIL 
      ::oCalex:oCalInfo = Self 
   endif
   
   ::oCalex:oCalInfo:lSelected = .F.
   ::oCalex:oCalInfo:Refresh()

   ::oCalex:oCalInfo = Self 
   
   ::lSelected = .T.
   ::Refresh()

RETURN NIL

//----------------------------------------------------------------------------// 

METHOD Move( nTop, nLeft, nRight, nBottom ) CLASS TCalInfo

   DEFAULT nTop    := ::aCoords[ CI_TOP    ]
   DEFAULT nLeft   := ::aCoords[ CI_LEFT   ]
   DEFAULT nBottom := ::aCoords[ CI_BOTTOM ]
   DEFAULT nRight  := ::aCoords[ CI_RIGHT  ]

   ::aCoords[ CI_TOP    ] = nTop               
   ::aCoords[ CI_LEFT   ] = nLeft    
   ::aCoords[ CI_BOTTOM ] = nBottom
   ::aCoords[ CI_RIGHT  ] = nRight

   //only paint the visible object   
   ::lVisible = nBottom > ::oCalex:nTopMargin .and. nTop < ::oCalex:nHeight
   
RETURN NIL   

//----------------------------------------------------------------------------// 

METHOD Paint( hDC ) CLASS TCalInfo 

   local cFrom := ::oCalex:oView:ClassName()

//   switch cFrom
//      case "TMONTHVIEW"
//         ::PaintOnMonth( hDC )
//         exit 
//   endswitch
   
   ::PaintOnMonth( hDC )   
   
return nil

//----------------------------------------------------------------------------// 

METHOD PaintOnMonth( hDC ) CLASS TCalInfo
   
   local hBrush, hOldBrush
   local hOldFont, nTextWidth
   local cTime, nOldClr
   local hPen, hOldPen
   local nAdj := 0
   local cFrom := ::oCalex:oView:ClassName()   
   local bPaint
   
   if ! ::lVisible
      return nil 
   endif

   if cFrom == "TMONTHVIEW"
         bPaint = {| hDC, aCoords | DrawBox( hDC, aCoords ) }      
   else
         bPaint = {| hDC, aCoords | DrawSpecialBox( hDC, aCoords ) }               
   endif
   
   
   	            	
   hBrush = GradientBrush( hDC, ::aCoords[ 1 ], ::aCoords[ 2 ], ::aCoords[ 4 ], ::aCoords[ 3 ], ::aGradColor )

   hPen = CreatePen( PS_NULL, 0, 0 )
   
   hOldPen = SelectObject( hDC, hPen )
   
   hOldBrush = SelectObject( hDC, hBrush )

   BeginPath( hDC )
   
   Eval( bPaint, hDC, ::aCoords )
   
   EndPath( hDC )
   
   StrokeAndFillPath( hDC )

   SelectObject( hDC, hOldPen )
   DeleteObject( hPen )
   
   if ! ::lSelected   
      hPen = CreatePen( PS_SOLID, 1, ::oCalex:nColorGrid )
   else 
      hPen = CreatePen( PS_SOLID, 2, ::oCalex:nColorCellSelected )
      nAdj = 1
   endif
   
   hOldPen = SelectObject( hDC, hPen )
   
   Eval( bPaint, hDC, ::aCoords )
      
   hOldFont = SelectObject( hDC, ::oFont:hFont )
   
   cTime = ConvertTime( ::nStart, ::oCalex:lAmPm )
   
   SetTextColor( hDC, ::nClrText )

   DrawTextTransparent( hDC, cTime + "  " + ::cSubject , ;
                        { ::aCoords[ 1 ], ::aCoords[ 2 ] + 3, ::aCoords[ 3 ], ::aCoords[ 4 ] - 3 }, nOR( DT_SINGLELINE, DT_VCENTER ) )                        

   SetTextColor( hDC, nOldClr )
   
   SelectObject( hDC, hOldFont )      
   SelectObject( hDC, hOldBrush )
   
   SelectObject( hDC, hOldPen )
   DeleteObject( hPen )

   DeleteObject( hBrush )
   

return 0 

//----------------------------------------------------------------------------// 