//tcalex.prg

#include "fivewin.ch"
#include "calex.ch"

CLASS TCalEx FROM TControl 

   DATA hCalInfo                    // Hash with CalInfo object
   DATA aInterval                   // Array with interval minutes

   DATA dStart, dEnd, dDate, dDateSelected AS DATE
   DATA bSelected, bSelectedWeek
   DATA bSelectView

   DATA bOnNext
   DATA bOnPrev
   
   DATA hDays                         // days hash
   DATA hNextItem, hPrevItem         // Bitmaps handle next/prev "button" normal status
   DATA hNextItemo, hPrevItemo       // Bitmaps handle next/prev "button" over mouse status
   
   DATA	lLeftLabel                   // Show/Hide vertical left label
   DATA lOverNext, lOverPrev         // used internally to check over next/prev bitmap
   DATA lSBVisible                   // used internally to check vertical scroll is visible
   DATA lActive                      // 
   DATA lAmPm         // am-pm format
   DATA lWorking
   
   
   DATA aOverCell                     // Coordenates of over cell    
   DATA aLabelText                    // left text (week)
   DATA aDateSelected                 // Position date selected
   DATA aGradCellNormal               // Gradient cell color, normal status
   DATA aGradCellSelected             // Gradient selected day
   DATA aGradHeaderCel                // Gradient Header cell color
   DATA aGradHeaderCelDay             // Gradient Header cell color of current day
   DATA aGradDifMonth                 // Gradient cell for diferent current month selected
   DATA aTodayPos                     // array position of Today   
   
   DATA nAtRow, nAtCol                // Mouse position cell
   DATA nColorGrid                    // Grid line color
   DATA nColorGrid2                   // Grid internal line color
   DATA nColorCellSelected            // Color of border in cell selected
   DATA nColorGridToday               // Today Grid line color
   DATA nDNameHeight                  // Day Name header size
   DATA	nLeftLabelWidth               // Left label width size
   DATA nBottomMargin                 // Bottom Margin
   DATA	nLeftMargin                   // Left Margin
   DATA nRightMargin                  // Right Margin
   DATA nTopMargin                    // Top Margin
   DATA nWeek                         // nWeek Selected
   DATA nBtnPushed                    // 0 none 
                                      // 2 Next
                                      // 1 Prev
                                      
   DATA nWks                          // Total week in month
   DATA nDays        PROTECTED                 // Total days in view ( 1 / 7 )
   
   DATA nVirtualHeight
   DATA nVirtualTop
   DATA nStartHour   AS NUMERIC
   DATA nEndHour     AS NUMERIC
   DATA nInterval    AS NUMERIC
   
   DATA nAtRow, nAtCol                // cell at position


   DATA oFontHeader, oFontLabel, oFontTop
   
   DATA oView                         // Current view active
   DATA oMonthView                    // Month view   
   DATA oWeekView                     // Week View
   DATA oDayView                      // Day View
   
   DATA oCalInfo                      // Current Callendar Info object selected
   
   DATA oVScroll
   
 
   CLASSDATA lRegistered AS LOGICAL 

   METHOD New( nTop, nLeft, nWidth, nHeight, oWnd, ;
               nClrText, oBrush ) CONSTRUCTOR
   
   METHOD BuildDates()
               
   METHOD CheckChildren( oCalInfo )              
   METHOD CheckScroll()   
   METHOD CheckOverPrev( nRow, nCol )       
   
   METHOD EraseBkGnd( hDC ) INLINE 0 
   
   METHOD Display() INLINE ::BeginPaint(), ::Paint(), ::EndPaint(), 0 
   METHOD Destroy() 

   METHOD GetCoorFromPos( nAtRow, nAtCol ) 
   METHOD GetCoorFromTime( nTime, dDate )
   METHOD GetFirstDateWeek()
   METHOD GetInfoFromCoors( nRow, nCol, dDate )
   METHOD GetLastDateWeek()
   METHOD GetStrInterval( nStart )       
   METHOD GridWidth()    INLINE ::nWidth - ::nRightMargin - 2 - ;
                                ( ::nLeftMargin + ::nLeftLabelWidth ) - If( ::lSBVisible, GetSysMetrics( SM_CXVSCROLL ), 0 )
   METHOD GridHeight()   INLINE ::nHeight - ::nBottomMargin - 2 

   METHOD HitTest( nRow, nCol ) 

   METHOD LButtonDown( nRow, nCol, nKeyFlags ) 
   METHOD LButtonUp( nRow, nCol, nKeyFlags ) 
   METHOD Line( hDC, nTop, nLeft, nBottom, nRight, nColor )
   METHOD LoadDates()
   
   METHOD MouseMove( nRow, nCol, nKeyFlags ) 
   METHOD MouseWheel( nKeys, nDelta, nXPos, nYPos ) INLINE ::oView:MouseWheel( nKeys, nDelta, nXPos, nYPos )
   
   METHOD MoveCalInfo()

   METHOD NextInterval()

   METHOD Paint() 
   METHOD PaintCalInfo( hDC )
   METHOD PaintHorzLinesWithLeftLabels()	//used in dayv as well as weekv
   
   METHOD Resize( nType, nWidth, nHeight ) INLINE ::oView:CheckScroll(), ::oView:Resize( nType, nWidth, nHeight ), Super:Resize( nType, nWidth, nHeight )
   METHOD Reset() INLINE ::hCalInfo := hb_HASH(), ::aOverCell := NIL
   
   
   METHOD SetDatas( oView )
   METHOD SetDate( dDate ) INLINE ::oView:SetDate( dDate )

   METHOD SetInterval( nMin )  //   Values allowed { 5, 10, 15, 20, 30, 60 }
   
   METHOD SetView(o)
   METHOD SetMonthView()  INLINE ::SetView( ::oMonthView )
   METHOD SetWeekView( dDate )   
   METHOD SetDayView( dDate )
   METHOD SetScroll()
   
   METHOD VerifyPos( oCalInfo, oLast )
   METHOD VScrollSetPos( nPos ) 
   METHOD VScrollSkip( nSkip )    
   
   METHOD UpdateOverCell() INLINE    If( ::aOverCell != NIL, ::aOverCell := ::GetCoorFromPos( ::nAtRow, ::nAtCol ), )

ENDCLASS 

//----------------------------------------------------------------------------// 

METHOD New( nTop, nLeft, nWidth, nHeight, oWnd, ;
            nClrText, oBrush ) CLASS TCalEx 

   local nMod, aFontInfo, n

   DEFAULT nWidth  := 600,; 
           nHeight := 600,; 
           nLeft   := 0,; 
           nTop    := 0,;
           oWnd    := GetWndDefault() 

   ::nTop       = nTop 
   ::nLeft      = nLeft 
   ::nBottom    = nTop + nHeight - 1 
   ::nRight     = nLeft + nWidth - 1 
   ::oWnd       = oWnd 
   
   
   //Dates
   ::dDate = Date()
   ::dDateSelected := ::dDate
   
   //Bmp Handles
   ::hNextItem   = hNextItem()
   ::hPrevItem   = hPrevItem()
   ::hNextItemo  = hNextItemo()
   ::hPrevItemo  = hPrevItemo()

   ::nClrText   = nClrText
   ::nStyle     = nOr( WS_CHILD, WS_VISIBLE, WS_TABSTOP, WS_BORDER, WS_CLIPCHILDREN ) 
   
   
   //Array
   ::aGradCellNormal   = { { 1, nRGB( 255, 255, 255 ), nRGB( 255, 255, 255 ) } } 
   ::aGradHeaderCel    = { { 1, nRGB( 165, 191, 225 ), nRGB( 165, 191, 225 ) } }    
   ::aGradDifMonth     = { { 1, nRGB( 165, 191, 225 ), nRGB( 165, 191, 225 ) } } 
   ::aGradCellSelected  = { { 1, nRGB( 230, 237, 247 ), nRGB( 230, 237, 247 ) } } 
   ::aGradHeaderCelDay = { { 1/2, nRGB( 255, 237, 121 ), nRGB( 255, 216, 157 ) },;
                           { 1/2, nRGB( 255, 216, 157 ), nRGB( 255, 237, 121 ) } }    
                           	
   ::Reset()
   
   //LOGICAL
   ::lLeftLabel		= .T.
   ::lOverPrev    = .F.
   ::lOverNext    = .F.
   ::lSBVisible   = .F.
   ::lActive      = .F.
   
   //Numeric
   ::nColorGrid       = nRGB( 141, 174, 217 )
   ::nColorGrid2      = nRGB( 230, 237, 247 )
   ::nColorCellSelected = 0
   ::nColorGridToday  = nRGB( 235, 137, 000 )
   ::nDNameHeight     = 20
   ::nLeftLabelWidth  = 20
   ::nLeftMargin      = 2
   ::nRightMargin     = 2
   ::nBottomMargin    = 2
   ::nTopMargin       = 60
   ::nWeek            = 0
   ::nStartHour	  	  = 0.00
   ::nEndHour         = 24.00
   ::nVirtualHeight   = ::nHeight
	
   if ::oFont != NIL
      ::oFont:End()
   endif

   aFontInfo = GetFontInfo( GetStockObject( DEFAULT_GUI_FONT ) ) 
   
   DEFINE FONT ::oFont NAME aFontInfo[ 4 ] SIZE aFontInfo[ 2 ], aFontInfo[ 1 ]
   DEFINE FONT ::oFontHeader NAME aFontInfo[ 4 ] SIZE aFontInfo[ 2 ], aFontInfo[ 1 ] BOLD
   DEFINE FONT ::oFontTop NAME aFontInfo[ 4 ] SIZE aFontInfo[ 2 ] * 2, aFontInfo[ 1 ] * 2
   ::oFontLabel = TFont():New( aFontInfo[ 4 ], aFontInfo[ 2 ], aFontInfo[ 1 ], , , 900, 900 )

   #ifdef __XPP__ 
      DEFAULT ::lRegistered := .F. 
   #endif 

   if oBrush == NIL
      ::SetBrush( ::oWnd:oBrush )
   else
      ::SetBrush( oBrush )
   endif

   ::Register() 

   if ! Empty( oWnd:hWnd ) 
      ::Create() 
      oWnd:AddControl( Self ) 
   else 
      oWnd:DefControl( Self ) 
   endif 

   DEFINE SCROLLBAR ::oVScroll VERTICAL OF Self
   
   ::oMonthView = TMonthView():New( Self )
   ::oWeekView  = TWeekView():New( Self )
   ::oDayView   = TDayView():New( Self )
   ::SetMonthView()
   

return Self 

//----------------------------------------------------------------------------// 

METHOD Destroy() CLASS TCalEx 

   ::oFontHeader:End() 
   ::oFontLabel:End()
   DeleteObject( ::hNextItem  )
   DeleteObject( ::hPrevItem  ) 
   DeleteObject( ::hNextItemo ) 
   DeleteObject( ::hPrevItemo )
   
return Super:Destroy() 


//----------------------------------------------------------------------------// 

METHOD BuildDates() CLASS TCalEx

   local oCalInfo
   local cStrDay, aInfo, aInfo2
   local aPos, aCoor
   local n, j
   local nAt, nHour, nMin, cStrInterval, hInfo
   local nTime
   locaL nColStep := Int( ::GridWidth() / ::nDays )
   local nModCol := ::GridWidth() % ::nDays - 1
   local dLastDateWeek, oLast

   dLastDateWeek  := ::GetLastDateWeek()
   ::hDays        = hb_HASH()
   
   
   //fill and sort dates by day
   for each oCalInfo in ::oCalex:hCalInfo
#ifdef __XHARBOUR__
      oCalInfo = oCalInfo:Value
#endif   
      aInfo = {}
      hInfo       = hb_HASH()
      if oCalInfo:dStart >= ::dStart .and. oCalInfo:dStart <= ::dEnd
         cStrDay = DToS( oCalInfo:dStart )

         if hb_HHASKEY( ::hDays, cStrDay )
            hInfo := hb_HGET( ::hDays, cStrDay )
         endif

         nTime = oCalInfo:nStart
         
         cStrInterval = ::GetStrInterval( oCalInfo:nStart )
         
         
         if hb_HHASKEY( hInfo, cStrInterval )
            aInfo = hb_HGET( hInfo, cStrInterval )
         else 
            hb_HSET( hInfo, cStrInterval, aInfo )
         endif
         oCalInfo:lCreated = .F.      
         AAdd( aInfo, oCalInfo )
         
         ASort( aInfo, , ,{| o1, o2 | o1:nStart < o2:nStart } ) 
         
         hb_HSET( ::hDays, cStrDay, hInfo )
         
      endif
      
   next  

   if ! Empty( ::hDays )
      
      aCoor = { NIL, NIL }
      for each hInfo in ::hDays
         n = 0
#ifdef __XHARBOUR__
         hInfo = hInfo:Value
#endif
         for each aInfo in hInfo //oCalInfo in aInfo
#ifdef __XHARBOUR__
            aInfo = aInfo:Value
#endif 
            
            for each oCalInfo in aInfo
               n++
               if n == 1
                  aCoor[ 1 ] = ::GetCoorFromTime( oCalInfo:nStart, oCalInfo:dStart )
                  aCoor[ 2 ] = ::GetCoorFromTime( oCalInfo:nEnd, oCalInfo:dStart )
                  ::oCalex:oWnd:oWnd:oWnd:cTitle = Str( aCoor[ 1 ][ 2 ] ) + Str( ::GridWidth() ) 

                  oCalInfo:BuildDates( aCoor[ 1 ][ 1 ], ;
                                       aCoor[ 1 ][ 2 ], ;
                                       nColStep + If( oCalInfo:dStart == dLastDateWeek, nModCol, 0 ),; 
                                       Max( ::nRowHeight, aCoor[ 2 ][ 1 ] - aCoor[ 1 ][ 1 ] ) + 1, ::oCalex )
                  oCalInfo:nFlags = FLAGS_START                            
                  ::VerifyPos()
               else 
                  ::VerifyPos( oCalInfo, oLast )
               endif
               oLast = oCalInfo
            next 
         next
      next    
   endif   
   
   ::Resize() 
//   if !Empty( ::hDays )
//      xbrowse( ::hDays )
//   endif

RETURN NIL

//----------------------------------------------------------------------------// 

METHOD CheckChildren( oCalInfo ) CLASS TCalEx

   local cStrDay := DToS( oCalInfo:dStart )
   local hInfo
   local nMin, nHour
   local nTot := 1, lRet := .T.
   local cStrInterval, aTempInfo, n := 1, j := 2
   local nStart := oCalInfo:nStart

   if hb_HHASKEY( ::hDays, cStrDay )
      hInfo := hb_HGET( ::hDays, cStrDay )
   endif
   
   //verify more children in other interval
   while lRet
      cStrInterval := ::GetStrInterval( nStart )      
      if hb_HHASKEY( hInfo, cStrInterval )
         aTempInfo = hb_HGET( hInfo, cStrInterval )
         if Len( aTempInfo ) > 0
            for n = j to Len( aTempInfo )
               if nAND( aTempInfo[ n ]:nFlags, FLAGS_RIGHT ) == FLAGS_RIGHT
                  nTot ++
               elseif aTempInfo[ n ]:nFlags == FLAGS_START
                  lRet = .F.
               endif 
            next
         endif
      endif
      nStart = ::NextInterval( nStart )
      j = 1
      lRet = nStart > 0 .and. lRet      
   enddo 
   
return nTot 

//----------------------------------------------------------------------------// 

METHOD CheckOverPrev( nRow, nCol ) CLASS TCalEx

    // check over Prev
   if nRow > ROWITEM .and. nRow < ROWITEM + BMPITEMH
      if nCol > COLPREV .and. nCol < COLPREV + BMPITEMW 
         ::lOverPrev = .T.
         ::lOverNext = .F.
      elseif nCol > COLNEXT .and. nCol < COLNEXT + BMPITEMW 
         ::lOverNext = .T.          
         ::lOverPrev = .F.
      elseif ::lOverNext .or. ::lOverPrev
         ::lOverNext = .F.
         ::lOverPrev = .F.
      endif   
   elseif ::lOverNext .or. ::lOverPrev
      ::lOverNext = .F.
      ::lOverPrev = .F.      
   endif
   
      
RETURN NIL


//----------------------------------------------------------------------------// 

METHOD CheckScroll() CLASS TCalEx

   local nLastRow
   local nPos
   
   if ! ::lActive
      RETURN nil
   endif
   
   nLastRow := ::GridHeight() + ::nTopMargin
   if nLastRow > ::nHeight
      ::nVirtualHeight = nLastRow
      SetScrollRangeX( ::hWnd, 1, 0, ::nVirtualHeight - 1) 

      if  (::nVirtualHeight - ::nVirtualTop) < ::nHeight
         ::nVirtualTop := ::nVirtualHeight - ::nHeight
      endif   

      ::oVScroll:SetPage( ::nHeight, .F. )
      ::oVScroll:SetPos( ::nVirtualTop )
      ::lSBVisible = .T.

   else 
      ::nVirtualTop = 0
      ::nVirtualHeight = ::nHeight
      SetScrollRangeX( ::hWnd, 1, 0, 0 )
      ::lSBVisible = .F.
   endif
   
//   ? ::ClassName(), ::lSBVisible, ProcName( 1 ), ProcLine( 1 )

   ::oWnd:SetFocus()
      
RETURN nil 

//----------------------------------------------------------------------------// 

METHOD GetCoorFromPos( nAtRow, nAtCol ) CLASS TCalEx

   local nColStep, nModCol, nRowStep
   local nGridWidth  := ::GridWidth()
   local nGridHeight := ::GridHeight()   
   local aCoor := Array( 4 ) //Top, Left, Bottom, Right
   
   nColStep = Int( nGridWidth / ::nDays )
   nModCol = nGridWidth % ::nDays

   nRowStep = ::nRowHeight
   
   aCoor[ 1 ] = Max( 0, ( nAtRow - 1 ) * nRowStep + ::nTopMargin - ::nVirtualTop + 1 )
   aCoor[ 2 ] = ( nAtCol - 1 ) * nColStep + ::nLeftMargin + ::nLeftLabelWidth + 1
   aCoor[ 3 ] = aCoor[ 1 ] + nRowStep - 1 
   aCoor[ 4 ] = aCoor[ 2 ] + nColStep + If( nAtCol == ::nDays, nModCol, 0 ) - 1
   
RETURN aCoor

//----------------------------------------------------------------------------// 

METHOD GetCoorFromTime( nTime, dDate ) CLASS TCalEx
   local nRow, nCol 
   local nHour 
   local nMin
   local nIntByHour := 60 / ::nInterval   
   local dFirstDateWeek := ::GetFirstDateWeek()//::dDateSelected - DoW( ::dDateSelected ) + 1
   locaL nColStep := Int( ::GridWidth() / ::nDays )
   local aCoor := Array( 4 )
   local nTimeTemp := nTime - ::nStartHour * 100
   
   
   nCol := ( dDate  -  dFirstDateWeek ) * nColStep + ::nLeftMargin + ::nLeftLabelWidth + 1
   
   nHour = Int( nTimeTemp / 100 )   
   nMin  = nTimeTemp - nHour * 100
   
   nRow := nHour * nIntByHour * ::nRowHeight + ::nRowHeight * nMin / ::nInterval + ::nTopMargin
   
RETURN { nRow, nCol }

//----------------------------------------------------------------------------// 

METHOD GetFirstDateWeek() CLASS TCalEx 
   local dFirstDateWeek
   
   if ::Classname() != "TDAYVIEW"
      dFirstDateWeek  = ::dDateSelected - DoW( ::dDateSelected ) + 1 
   else 
      dFirstDateWeek  = ::dDateSelected
   endif
   
RETURN dFirstDateWeek

//----------------------------------------------------------------------------// 

METHOD GetInfoFromCoors( nRow, nCol, dDate ) CLASS TCalEx

   local oCalInfo, oCalRet
   local hInfo, aInfo
   local nTempRow := nRow //- ::nVirtualTop 
   local nTempCol := nCol //+ ::nLeftLabelWidth - ::nLeftMargin
   if ! Empty( ::hDays )
      
      for each hInfo in ::hDays
#ifdef __XHARBOUR__
         hInfo = hInfo:Value
#endif
         for each aInfo in hInfo //oCalInfo in aInfo
#ifdef __XHARBOUR__
            aInfo = aInfo:Value
#endif 
            
            for each oCalInfo in aInfo
               if dDate == oCalInfo:dStart
                  if oCalInfo:aCoords[ CI_TOP ] < nTempRow .and. oCalInfo:aCoords[ CI_BOTTOM ] > nTempRow .and. ;
                     oCalInfo:aCoords[ CI_LEFT ] < nTempCol .and. oCalInfo:aCoords[ CI_RIGHT ] > nTempCol
                     oCalRet = oCalInfo
                     exit
                  endif
               endif
            next 
         next
      next    
   endif     
   
return oCalRet

//----------------------------------------------------------------------------// 

METHOD GetLastDateWeek() CLASS TCalEx 
   local dLastDateWeek
   
   if ::Classname() != "TDAYVIEW"
      dLastDateWeek  := ::GetFirstDateWeek() + ::nDays - 1
   else 
      dLastDateWeek  := ::dDateSelected
   endif
   
RETURN dLastDateWeek
      
//----------------------------------------------------------------------------// 

METHOD GetStrInterval( nStart ) CLASS TCalEx
   
   local nHour, nMin, cStrInterval, nAt 

   nHour = Int( nStart / 100 )
   nMin  = nStart - nHour * 100
 
   nAt   = AScan( ::aInterval, {| nVal | nMin < nVal } ) - 1
   if nAt > 0 
      cStrInterval = StrZero( Val( Str( nHour, 2 ) ), 2 ) + StrZero( Val( Str( ::aInterval[ nAt ], 2 ) ), 2 )
   else 
      cStrInterval = StrZero( Val( Str( nHour, 2 ) ), 2 ) + StrZero( Val( Str( ATail( ::aInterval ), 2 ) ), 2 )
   endif
   
return cStrInterval

//----------------------------------------------------------------------------// 

METHOD HitTest( nRow, nCol ) CLASS TCalEx
   local nGridWidth := ::GridWidth()
   local nColStep , nModCol
   local nAtCol, nAtRow
   local nRowStep := ::nRowHeight   
   local aCoor
   local aRet
   local oCalInfo
   local dFirstDateWeek := ::GetFirstDateWeek()//::dDateSelected - DoW( ::dDateSelected ) + 1
   
   nColStep = Int( nGridWidth / ::nDays )
   nModCol = nGridWidth % ::nDays
   
   nAtCol = Min( Int( ( nCol - ::nLeftLabelWidth - ::nLeftMargin ) / nColStep ) + 1, ::nDays )
   //logical row      
   nAtRow := Int( ( nRow + ::nVirtualTop - ::nTopMargin ) / nRowStep ) + 1   
   
   ::nAtRow = 0
   ::nAtCol = 0
   if nRow < ::nTopMargin .and. nRow > ::nTopMargin - ::nDNameHeight
      aRet = { HITTEST_HEADER, nAtCol }
   elseif nRow > ::nTopMargin .and. nCol > ::nLeftLabelWidth + ::nLeftMargin .and. nRow < ::GridHeight() + ::nTopMargin
      ::nAtRow = nAtRow
      ::nAtCol = nAtCol 
      aCoor = ::GetCoorFromPos( nAtRow, nAtCol )
      //verify is over oCalInfo object
      oCalInfo := ::GetInfoFromCoors( nRow, nCol, dFirstDateWeek + nAtCol - 1 )
      if oCalInfo != NIL
         oCalInfo:lSelected = .T.
      elseif ::oCalex:oCalInfo != NIL
         ::oCalex:oCalInfo:lSelected  = .F.
      endif
      ::oCalex:oCalInfo  = oCalInfo
      aRet = { HITTEST_BODY, If( ::oCalex:oCalInfo != NIL, NIL, aCoor ) }
   else 
      ::nAtRow = nAtRow
      aRet = { HITTEST_TIME, nAtRow }
   endif

return aRet

//----------------------------------------------------------------------------// 


METHOD LButtonDown( nRow, nCol, nKeyFlags ) CLASS TCalEx 
   
   if ::oCalInfo != NIL 
      ::oCalInfo:lSelected = .F.
   endif

   ::oView:LButtonDown( nRow, nCol, nKeyFlags )
   
   ::Refresh()

return Super:LButtonDown( nRow, nCol, nKeyFlags ) 


//----------------------------------------------------------------------------// 

METHOD LButtonUp( nRow, nCol, nKeyFlags ) CLASS TCalEx 

   ::oView:LButtonUp( nRow, nCol, nKeyFlags )

return Super:LButtonUp( nRow, nCol, nKeyFlags )

//-----------------------------------------------------------------// 

METHOD Line( hDC, nTop, nLeft, nBottom, nRight, nColor ) CLASS TCalEx

   local hPen, hOldPen

   
   hPen = CreatePen( PS_SOLID, 1, nColor )
   hOldPen = SelectObject( hDC, hPen )
   MoveTo( hDC, nLeft, nTop )
   LineTo( hDC, nRight, nBottom )
   SelectObject( hDC, hOldPen )   
   DeleteObject( hPen )
   

return nil

//-----------------------------------------------------------------// 

METHOD LoadDates( nStart, nEnd, dStart, dEnd, cText, cSubject ) CLASS TCalEx

   local oCalInfo 
   
   oCalInfo = TCalInfo():New( Self, nStart, nEnd, dStart, dEnd, cText, cSubject )
   
   hb_HSET( ::hCalInfo, oCalInfo:nId, oCalInfo )

RETURN NIL

//----------------------------------------------------------------------------// 

METHOD MoveCalInfo( nSkip ) CLASS TCalEx

   local aInfo, hInfo, oCalInfo

   if ! Empty( ::hDays )

      for each hInfo in ::hDays
#ifdef __XHARBOUR__
         hInfo = hInfo:Value
#endif
         for each aInfo in hInfo //oCalInfo in aInfo
#ifdef __XHARBOUR__
            aInfo = aInfo:Value
#endif
            for each oCalInfo in aInfo
               oCalInfo:Move( oCalInfo:aCoords[ CI_TOP ] - nSkip, , , oCalInfo:aCoords[ CI_BOTTOM ] - nSkip )
            next
         next
      next    
   endif  

return nil
 

//-----------------------------------------------------------------// 

METHOD MouseMove( nRow, nCol, nKeyFlags ) CLASS TCalEx


   ::oView:MouseMove( nRow, nCol, nKeyFlags )

return Super:MouseMove( nRow, nCol, nKeyFlags )

//----------------------------------------------------------------------------// 
//adds next ::nInterval to last appnmnt time.  Used to calculate left hourly labels
METHOD NextInterval( nTime ) CLASS TCalEx
   local nMinutes := Val( Right( StrZero( nTime, 4 ), 2 ) )
   local nHour    := ( nTime - nMinutes ) / 100
   
   nMinutes += ::nInterval
   if nMinutes > 59
      nMinutes = 0 
      nHour ++
      if nHour > 23 
         nHour = 0
      endif 
   endif 
   
   nTime := nHour * 100 + nMinutes

RETURN nTime

//----------------------------------------------------------------------------// 


METHOD Paint() CLASS TCalEx

   local aInfo := ::DispBegin() 
   local oCalInfo

   ::oView:Paint( ::hDC )
   
   ::DispEnd( aInfo ) 

return 0 

//----------------------------------------------------------------------------// 

METHOD PaintCalInfo( hDC ) CLASS TCalEx

   local oCalInfo
   local aInfo, hInfo

   for each hInfo in ::hDays
#ifdef __XHARBOUR__
      hInfo = hInfo:Value
#endif
      for each aInfo in hInfo //oCalInfo in aInfo
#ifdef __XHARBOUR__
         aInfo = aInfo:Value
#endif 
         for each oCalInfo in aInfo
            oCalInfo:Paint( hDC )
         next 
      next
   next 
   
RETURN NIL 


//----------------------------------------------------------------------------// 
//called from week and daily view to draw left margin hourly lables
//Horizontal Lines
//
METHOD PaintHorzLinesWithLeftLabels( hDC ) CLASS TCalEx	
   local nGridWidth  := ::GridWidth()
   local n, nColStep, nRowStep
   local nTop, nBottom
   local aLabelArea
   local cTime := ""
   local nTime

   //::ResetNextInterval()

   nRowStep   = ::nRowHeight
   
   nTime      = ::nStartHour * 100 
   
   for n = 1 to ::nRowCount 
   
      nTop    = ::nTopMargin + ( n * nRowStep ) - ::nVirtualTop
//      nBottom = ::nTopMargin + ( n * nRowStep ) - ::nVirtualTop
      
      //Only paint the visibles rows
      if nTop > 0 .and. nTop < ::nHeight + nRowStep

         if nTime % 100 == 0
            ::Line( hDC, nTop - nRowStep,;
                    ::nLeftMargin,;
                    nTop - nRowStep,;
                    nGridWidth + ::nLeftMargin + ::nLeftLabelWidth,;
                    ::nColorGrid )      
    
         //Show Left label

            aLabelArea = { ::nTopMargin + ( ( n - 1 ) * nRowStep ) - ::nVirtualTop, ;
                           ::nLeftMargin, ::nTopMargin + ( n  * nRowStep ) - ::nVirtualTop, ;
                           ::nLeftLabelWidth - 2 }
         

	          cTime = ConvertTime( nTime )                            
            DrawTextTransparent( hDC, cTime , ;
                             aLabelArea, nOR( DT_SINGLELINE, DT_VCENTER, DT_RIGHT ) )
         else 
            ::Line( hDC, nTop - nRowStep,;
                    ::nLeftMargin + ::nLeftLabelWidth + 1,;
                    nTop - nRowStep,;
                    nGridWidth + ::nLeftMargin + ::nLeftLabelWidth,;
                    ::nColorGrid2 ) 
                    
            ::Line( hDC, nTop - nRowStep,;
                    ::nLeftMargin + ::nLeftLabelWidth / 2,;
                    nTop - nRowStep,;
                    ::nLeftMargin + ::nLeftLabelWidth - 4,;
                    ::nColorGrid ) 
         endif
         if n = ::nRowCount
           ::Line( hDC, nTop,;
                   ::nLeftMargin,;
                   nTop,;
                   nGridWidth + ::nLeftMargin + ::nLeftLabelWidth,;
                   ::nColorGrid )  
         endif
      endif                         
      nTime := ::NextInterval( nTime )

   next   

Return NIL

//----------------------------------------------------------------------------//    
   
METHOD SetDayView( dDate, nInterval )  CLASS TCalEx 
   DEFAULT dDate := ::oMonthView:GetDateFromPos( ::oMonthView:aDateSelected[ 1 ], ::oMonthView:aDateSelected[ 2 ] )
  
   // for compatibility with xharbour
   if dDate == NIL 
      dDate = CToD( "  /  /  " )
   endif
   
   ::oDayView:dDateSelected = dDate
   ::oDayView:dStart        = dDate 
   ::oDayView:dEnd          = dDate
   ::SetView( ::oDayView )
   
   DEFAULT nInterval := ::oView:nInterval
   
   ::oDayView:SetInterval( nInterval )
   
   
RETURN NIL

//----------------------------------------------------------------------------// 
// all data shared
METHOD SetDatas( oView ) CLASS TCalEx

   oView:oCalex            = Self
   oView:nTop              = ::nTop
   oView:nLeft             = ::nLeft
   oView:nBottom           = ::nBottom
   oView:nRight            = ::nRight
   oView:oWnd              = ::oWnd
   oView:hNextItem         = ::hNextItem
   oView:hPrevItem         = ::hPrevItem
   oView:hNextItemo        = ::hNextItemo
   oView:hPrevItemo        = ::hPrevItemo
   oView:nClrText          = ::nClrText
   oView:nStyle            = ::nStyle
   oView:aGradCellNormal   = ::aGradCellNormal
   oView:aGradHeaderCel    = ::aGradHeaderCel
   oView:aGradDifMonth     = ::aGradDifMonth
   oView:aGradCellSelected = ::aGradCellSelected
   oView:aGradHeaderCelDay = ::aGradHeaderCelDay
   oView:lLeftLabel		     = ::lLeftLabel
   oView:lOverPrev         = ::lOverPrev
   oView:lOverNext         = ::lOverNext
   oView:lSBVisible        = ::lSBVisible
   oView:nColorGrid        = ::nColorGrid
   oView:nColorGrid2       = ::nColorGrid2
   oView:nColorCellSelected = ::nColorCellSelected
   oView:nColorGridToday   = ::nColorGridToday
   oView:nDNameHeight      = ::nDNameHeight
   oView:nLeftLabelWidth   = ::nLeftLabelWidth
   oView:nLeftMargin       = ::nLeftMargin
   oView:nRightMargin      = ::nRightMargin
   oView:nBottomMargin     = ::nBottomMargin
   oView:nTopMargin        = ::nTopMargin
   oView:nWeek             = ::nWeek
   oView:oFont             = ::oFont
   oView:oFontHeader       = ::oFontHeader
   oView:oFontTop          = ::oFontTop
   oView:oFontLabel        = ::oFontLabel
   oView:oBrush            = ::oBrush
   oView:hWnd              = ::hWnd
   oView:dDate             = ::dDate
   oView:lActive           = ::lActive
   oView:nStartHour        = ::nStartHour
   oView:nEndHour          = ::nEndHour
   oView:oVScroll          = ::oVScroll

RETURN NIL

//----------------------------------------------------------------------------//

METHOD SetInterval( nMin ) CLASS TCalEx

   local aMin := { 5, 10, 15, 20, 30, 60 }
   local nAt, n

   DEFAULT nMin := 60.00

   if ! ::IsKindOf( "TMONTHVIEW" )
      ::aInterval := { 0 }
      
      if ::nStartHour >= ::nEndHour
         ::nEndHour = 24
      endif      
      
      nAt := AScan( aMin, {| n | nMin <= n } )

      if nAt > 0 
         nMin = aMin[ nAt ]
      else 
         nMin = 60.00
      endif

      ::nInterval := nMin
      ::nRowCount := ( ::nEndHour - ::nStartHour - If( ::nInterval == 60, 0 , 1 ) ) / ( ::nInterval / 60 )

      ::CheckScroll()  

      for n = 1 to 60 / nMin - 1
         AAdd( ::aInterval, Int( n * ::nInterval ) )
      next
      ::BuildDates()
       
   endif
   
RETURN NIL

//----------------------------------------------------------------------------// 

METHOD SetScroll() CLASS TCalEx

   ::oVScroll:bGoUp     = {|| ::VScrollSkip( - ::nRowHeight ) }
   ::oVScroll:bGoDown   = {|| ::VScrollSkip( ::nRowHeight ) }
   ::oVScroll:bPageUp   = {|| ::VScrollSkip( - ::oCalex:oView:oVScroll:nPgStep ) }
   ::oVScroll:bPageDown = {|| ::VScrollSkip( ::oCalex:oView:oVScroll:nPgStep ) }
   ::oVScroll:bPos      = {|nPos| ::VScrollSetPos( nPos ) }
   ::oVScroll:bTrack    = {|nPos| ::VScrollSetPos( nPos ) }

return nil


//----------------------------------------------------------------------------// 

METHOD SetView( o ) CLASS TCalEx
   
   local oLastView := ::oView
   
   local oCalInfo


   if ::oView != NIL
      ::oView:lActive = ! ::oView:lActive 
   endif

   o:oVScroll = ::oVScroll
   ::oView := o
   
   ::oView:lActive = .T.
   if ::oView:IsKindOf( "TMONTHVIEW" )
      ::oView:CheckScroll()
   endif
   ::oView:dDate = o:dDate

   hb_HEVAL( ::hCalInfo, {| k, v, i | v := NIl } )

   ::Reset()
      
   if ::oView:bSelectView != NIL 
      Eval( ::oView:bSelectView, o, oLastView ) // Last View Selected
   endif
   
   // only set the BuildDates in Month View 
   // because in other view is setted in SetInterval
   if ::oView:IsKindOf( "TMONTHVIEW" ) 
      ::oView:BuildDates()   
   endif
   
   ::oView:SetScroll()
   
   ::Refresh()



RETURN NIL

//----------------------------------------------------------------------------//    
   
METHOD SetWeekView( dDate, nInterval )  CLASS TCalEx 
   DEFAULT dDate := ::oMonthView:GetDateFromPos( ::oMonthView:aDateSelected[ 1 ], ::oMonthView:aDateSelected[ 2 ] )

   DEFAULT nInterval := ::oWeekView:nInterval
   
   
   // for compatibility with xharbour
   if dDate == NIL 
      dDate = CToD( "  /  /  " )
   endif
   
   ::oWeekView:dStart = dDate - DoW( dDate ) + 1
   ::oWeekView:dEnd   = ::oWeekView:dStart + 6

   ::oWeekView:dDateSelected := dDate
   
   ::SetView( ::oWeekView )

   ::oWeekView:SetInterval( nInterval )
   

   
RETURN NIL


//----------------------------------------------------------------------------// 
// oCalInfo current object to Verify
// oTempCal oCalInfo objects above created
//----------------------------------------------------------------------------// 

METHOD VerifyPos( oCalInfo, oLast ) CLASS TCalEx

   local hInfo
   local aTempInfo
   local oTempCal
   locaL nColStep := Int( ::GridWidth() / ::nDays )
   local nModCol  := ::GridWidth() % ::nDays - 1
   local nAdjCol, nPosCol := 0
   local aCoor    := { NIL, NIL }
   local nTot
   local nDays, nInfo, nTempInfo
   local cStrDay, cStrInterval, lRet := .T.

   static nMaxRow := 0
   static nTopRow := 0
   
   // first ocalinfo in date
   if oCalInfo == NIL .and. oLast == NIL 
      nMaxRow = 0
      nTopRow = 0 
      return nil
   endif

   cStrDay = DToS( oCalInfo:dStart )
   hInfo = hb_HGET( ::hDays, cStrDay )
   if nMaxRow == 0 
      nMaxRow = oLast:aCoords[ CI_BOTTOM ]
      nTopRow = oLast:aCoords[ CI_TOP ]
   endif
   
   aCoor[ 1 ] = ::GetCoorFromTime( oCalInfo:nStart, oCalInfo:dStart )
   aCoor[ 2 ] = ::GetCoorFromTime( oCalInfo:nEnd, oCalInfo:dStart )
   
   if aCoor[ 1 ][ 1 ] < nMaxRow
      if ! ( aCoor[ 1 ][ 1 ] < oLast:aCoords[ CI_BOTTOM ] )
         oCalInfo:BuildDates( aCoor[ 1 ][ 1 ], ;
                              oLast:aCoords[ CI_LEFT ] + 1, ;
                              oLast:aCoords[ CI_RIGHT ] - oLast:aCoords[ CI_LEFT ],;// + If( oCalInfo:dStart == dLastDateWeek, nModCol, 0 ),; 
                              Max( ::nRowHeight, aCoor[ 2 ][ 1 ] - aCoor[ 1 ][ 1 ] ) + 1, ::oCalex, nColStep )
         oCalInfo:nFlags = FLAGS_DOWN
         if oCalInfo:aCoords[ CI_BOTTOM ] > nMaxRow
            nMaxRow = oCalInfo:aCoords[ CI_BOTTOM ]
         endif                                       
      else                                 
         nTot := Int( nColStep / ( oLast:aCoords[ CI_RIGHT ] - oLast:aCoords[ CI_LEFT ] ) ) + 1
         nAdjCol = nColStep / nTot
//         ::oCalex:oWnd:oWnd:oWnd:cTitle = Str( nTot ) + Str( nColStep )
         oCalInfo:BuildDates( aCoor[ 1 ][ 1 ], ;
                              aCoor[ 1 ][ 2 ] + nAdjCol * ( nTot - 1 ), ;
                              nAdjCol,;// + If( oCalInfo:dStart == dLastDateWeek, nModCol, 0 ),; 
                              Max( ::nRowHeight, aCoor[ 2 ][ 1 ] - aCoor[ 1 ][ 1 ] ) + 1, ::oCalex, nColStep )
         if oCalInfo:aCoords[ CI_BOTTOM ] > nMaxRow
            nMaxRow = oCalInfo:aCoords[ CI_BOTTOM ]
         endif
         oCalInfo:nFlags = FLAGS_RIGHT
      endif
   else 
      oCalInfo:BuildDates( aCoor[ 1 ][ 1 ], ;
                           aCoor[ 1 ][ 2 ], ;
                           nColStep,;// + If( oCalInfo:dStart == dLastDateWeek, nModCol, 0 ),; 
                           Max( ::nRowHeight, aCoor[ 2 ][ 1 ] - aCoor[ 1 ][ 1 ] ) + 1, ::oCalex, nColStep )
      nTopRow = oCalInfo:aCoords[ CI_TOP ]
      nMaxRow = oCalInfo:aCoords[ CI_BOTTOM ]
      oCalInfo:nFlags = FLAGS_START
      oLast:nFlags = nOR( oLast:nFlags, FLAGS_END )
   endif

return nil

//----------------------------------------------------------------------------//

METHOD VScrollSetPos( nPos ) CLASS TCalEx

   local nSkip := nPos - ::nVirtualTop 

   ::nVirtualTop := nPos
   ::oVScroll:SetPos( nPos )

   ::UpdateOverCell()

   ::Refresh()
   
   ::MoveCalInfo( nSkip )
   

RETURN nil

//----------------------------------------------------------------------------//

METHOD VScrollSkip( nSkip ) CLASS TCalEx

   LOCAL nHeight := ( ::nVirtualHeight - ::nHeight )


   IF (::nVirtualTop == 0 .And. nSkip < 0) .Or. ;
      (::nVirtualTop == nHeight .And. nSkip > 0)
      RETURN nil
   ENDIF

   ::nVirtualTop += nSkip

   IF ::nVirtualTop < 0
      ::nVirtualTop := 0
   ELSEIF ::nVirtualTop > nHeight
      ::nVirtualTop := nHeight
   ENDIF
   ::oVScroll:SetPos( ::nVirtualTop )

   ::UpdateOverCell()
   
   ::Refresh()
   
   ::MoveCalInfo( nSkip )

RETURN nil

//----------------------------------------------------------------------------//

FUNCTION ConvertTime( nTime, l24 )
   
   local cTime
   local nHour, nMinutes
   local nAdj := 0

   DEFAULT l24 := .F. 
   
   if ! l24
      if nTime > 1259 // 12:59 pm
         nAdj = 1200
      endif
      nHour    := Int( ( nTime - nAdj ) / 100 )
      nMinutes = ( nTime - nAdj ) - ( nHour * 100 )
      cTime    = Str( nHour, 2 ) + ":" + StrZero( nMinutes, 2 ) + " " + If( nTime > 1159, "pm", "am" )
   else 
      nMinutes = If( nTime  == 0, 0, Val( Right( StrZero( nTime, 4 ), 2 ) ) )
      nHour    = If( nTime  == 0, 0, ( nTime - nMinutes ) / 100 )
      cTime    = Str( nHour, 2 ) + ":" + StrZero( nMinutes, 2 )
   endif

return cTime

//----------------------------------------------------------------------------//

FUNCTION DrawBox( hDC, aRect, nAdj )
   local aPoints
   DEFAULT nAdj := 0
   
   aPoints := { { aRect[ 2 ], aRect[ 1 ] },; //start
   	            { aRect[ 4 ], aRect[ 1 ] },; //top
   	            { aRect[ 4 ], aRect[ 3 ] },; //right
   	            { aRect[ 2 ], aRect[ 3 ] },; //Bottom
   	            { aRect[ 2 ], aRect[ 1 ] - nAdj } } //left

   PolyLine(  hDC,  aPoints )
   
return nil

//----------------------------------------------------------------------------//

FUNCTION DrawSpecialBox( hDC, aRect, nAdj )
   local aPoints
   DEFAULT nAdj := 0
   
   aPoints := { { aRect[ 2 ], aRect[ 1 ] },; //start
   	            { aRect[ 4 ], aRect[ 1 ] },; //top
   	            { aRect[ 4 ], aRect[ 3 ] },; //right
   	            { aRect[ 2 ] + 3, aRect[ 3 ] },; //Bottom
   	            { aRect[ 2 ] + 3, aRect[ 1 ] + 5 },; 
   	            { aRect[ 2 ], aRect[ 1 ] + 5 },; 
   	            { aRect[ 2 ], aRect[ 1 ] - nAdj } } //left

   PolyLine(  hDC,  aPoints )
   
return nil

//----------------------------------------------------------------------------//
